Chapter 23. DiscoveredClustersService
23.1. CountDiscoveredClusters Copy linkLink copied to clipboard!
GET /v1/count/discovered-clusters
CountDiscoveredClusters returns the number of discovered clusters after filtering by requested fields.
23.1.1. Description Copy linkLink copied to clipboard!
23.1.2. Parameters Copy linkLink copied to clipboard!
23.1.2.1. Query Parameters Copy linkLink copied to clipboard!
| Name | Description | Required | Default | Pattern |
|---|---|---|---|---|
| filter.names |
Matches discovered clusters of specific names. | - | null | |
| filter.types |
Matches discovered clusters of specific types. | - | null | |
| filter.statuses |
Matches discovered clusters of specific statuses. - STATUS_UNSPECIFIED: The status of the cluster is unknown. May occur if a secured cluster is missing the metadata for a possible match. - STATUS_SECURED: The discovered cluster was matched with a secured cluster. - STATUS_UNSECURED: The discovered cluster was not matched with a secured cluster. | - | null | |
| filter.sourceIds |
Matches discovered clusters of specific cloud source IDs. | - | null |
23.1.3. Return Type Copy linkLink copied to clipboard!
23.1.4. Content Type Copy linkLink copied to clipboard!
- application/json
23.1.5. Responses Copy linkLink copied to clipboard!
| Code | Message | Datatype |
|---|---|---|
| 200 | A successful response. | |
| 0 | An unexpected error response. |
23.1.6. Samples Copy linkLink copied to clipboard!
23.1.7. Common object reference Copy linkLink copied to clipboard!
23.1.7.1. ProtobufAny Copy linkLink copied to clipboard!
Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.
Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.
Example 1: Pack and unpack a message in C++.
Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
...
}
Example 2: Pack and unpack a message in Java.
Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
any.Unpack(foo)
...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
...
}
The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".
23.1.7.1.1. JSON representation Copy linkLink copied to clipboard!
The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:
package google.profile;
message Person {
string first_name = 1;
string last_name = 2;
}
{
"@type": "type.googleapis.com/google.profile.Person",
"firstName": <string>,
"lastName": <string>
}
If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):
{
"@type": "type.googleapis.com/google.protobuf.Duration",
"value": "1.212s"
}
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| typeUrl | String |
A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in | |||
| value | byte[] | Must be a valid serialized protocol buffer of the above specified type. | byte |
23.1.7.2. RuntimeError Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| error | String | ||||
| code | Integer | int32 | |||
| message | String | ||||
| details | List of ProtobufAny |
23.1.7.3. V1CountDiscoveredClustersResponse Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| count | Integer | int32 |
23.2. ListDiscoveredClusters Copy linkLink copied to clipboard!
GET /v1/discovered-clusters
ListDiscoveredClusters returns the list of discovered clusters after filtered by requested fields.
23.2.1. Description Copy linkLink copied to clipboard!
23.2.2. Parameters Copy linkLink copied to clipboard!
23.2.2.1. Query Parameters Copy linkLink copied to clipboard!
| Name | Description | Required | Default | Pattern |
|---|---|---|---|---|
| pagination.limit | - | null | ||
| pagination.offset | - | null | ||
| pagination.sortOption.field | - | null | ||
| pagination.sortOption.reversed | - | null | ||
| pagination.sortOption.aggregateBy.aggrFunc | - | UNSET | ||
| pagination.sortOption.aggregateBy.distinct | - | null | ||
| filter.names |
Matches discovered clusters of specific names. | - | null | |
| filter.types |
Matches discovered clusters of specific types. | - | null | |
| filter.statuses |
Matches discovered clusters of specific statuses. - STATUS_UNSPECIFIED: The status of the cluster is unknown. May occur if a secured cluster is missing the metadata for a possible match. - STATUS_SECURED: The discovered cluster was matched with a secured cluster. - STATUS_UNSECURED: The discovered cluster was not matched with a secured cluster. | - | null | |
| filter.sourceIds |
Matches discovered clusters of specific cloud source IDs. | - | null |
23.2.3. Return Type Copy linkLink copied to clipboard!
23.2.4. Content Type Copy linkLink copied to clipboard!
- application/json
23.2.5. Responses Copy linkLink copied to clipboard!
| Code | Message | Datatype |
|---|---|---|
| 200 | A successful response. | |
| 0 | An unexpected error response. |
23.2.6. Samples Copy linkLink copied to clipboard!
23.2.7. Common object reference Copy linkLink copied to clipboard!
23.2.7.1. DiscoveredClusterMetadataType Copy linkLink copied to clipboard!
| Enum Values |
|---|
| UNSPECIFIED |
| AKS |
| ARO |
| EKS |
| GKE |
| OCP |
| OSD |
| ROSA |
23.2.7.2. MetadataProviderType Copy linkLink copied to clipboard!
| Enum Values |
|---|
| PROVIDER_TYPE_UNSPECIFIED |
| PROVIDER_TYPE_AWS |
| PROVIDER_TYPE_GCP |
| PROVIDER_TYPE_AZURE |
23.2.7.3. ProtobufAny Copy linkLink copied to clipboard!
Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.
Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.
Example 1: Pack and unpack a message in C++.
Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
...
}
Example 2: Pack and unpack a message in Java.
Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
any.Unpack(foo)
...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
...
}
The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".
23.2.7.3.1. JSON representation Copy linkLink copied to clipboard!
The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:
package google.profile;
message Person {
string first_name = 1;
string last_name = 2;
}
{
"@type": "type.googleapis.com/google.profile.Person",
"firstName": <string>,
"lastName": <string>
}
If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):
{
"@type": "type.googleapis.com/google.protobuf.Duration",
"value": "1.212s"
}
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| typeUrl | String |
A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in | |||
| value | byte[] | Must be a valid serialized protocol buffer of the above specified type. | byte |
23.2.7.4. RuntimeError Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| error | String | ||||
| code | Integer | int32 | |||
| message | String | ||||
| details | List of ProtobufAny |
23.2.7.5. V1DiscoveredCluster Copy linkLink copied to clipboard!
DiscoveredCluster represents a cluster discovered from a cloud source.
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | UUIDv5 generated deterministically from the tuple (metadata.id, metadata.type, source.id). | |||
| metadata | |||||
| status | STATUS_UNSPECIFIED, STATUS_SECURED, STATUS_UNSECURED, | ||||
| source |
23.2.7.6. V1DiscoveredClusterCloudSource Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String |
23.2.7.7. V1DiscoveredClusterMetadata Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | Represents a unique ID under which the cluster is registered with the cloud provider. Matches storage.ClusterMetadata.id for secured clusters. | |||
| name | String | Represents the name under which the cluster is registered with the cloud provider. Matches storage.ClusterMetadata.name for secured clusters. | |||
| type | UNSPECIFIED, AKS, ARO, EKS, GKE, OCP, OSD, ROSA, | ||||
| providerType | PROVIDER_TYPE_UNSPECIFIED, PROVIDER_TYPE_AWS, PROVIDER_TYPE_GCP, PROVIDER_TYPE_AZURE, | ||||
| region | String | The region as reported by the cloud provider. | |||
| firstDiscoveredAt | Date | Timestamp at which the cluster was first discovered by the cloud source. | date-time |
23.2.7.8. V1DiscoveredClusterStatus Copy linkLink copied to clipboard!
- STATUS_UNSPECIFIED: The status of the cluster is unknown. May occur if a secured cluster is missing the metadata for a possible match.
- STATUS_SECURED: The discovered cluster was matched with a secured cluster.
- STATUS_UNSECURED: The discovered cluster was not matched with a secured cluster.
| Enum Values |
|---|
| STATUS_UNSPECIFIED |
| STATUS_SECURED |
| STATUS_UNSECURED |
23.2.7.9. V1ListDiscoveredClustersResponse Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| clusters | List of V1DiscoveredCluster |
23.3. GetDiscoveredCluster Copy linkLink copied to clipboard!
GET /v1/discovered-clusters/{id}
GetDiscoveredCluster retrieves a discovered cluster by ID.
23.3.1. Description Copy linkLink copied to clipboard!
23.3.2. Parameters Copy linkLink copied to clipboard!
23.3.2.1. Path Parameters Copy linkLink copied to clipboard!
| Name | Description | Required | Default | Pattern |
|---|---|---|---|---|
| id | X | null |
23.3.3. Return Type Copy linkLink copied to clipboard!
23.3.4. Content Type Copy linkLink copied to clipboard!
- application/json
23.3.5. Responses Copy linkLink copied to clipboard!
| Code | Message | Datatype |
|---|---|---|
| 200 | A successful response. | |
| 0 | An unexpected error response. |
23.3.6. Samples Copy linkLink copied to clipboard!
23.3.7. Common object reference Copy linkLink copied to clipboard!
23.3.7.1. DiscoveredClusterMetadataType Copy linkLink copied to clipboard!
| Enum Values |
|---|
| UNSPECIFIED |
| AKS |
| ARO |
| EKS |
| GKE |
| OCP |
| OSD |
| ROSA |
23.3.7.2. MetadataProviderType Copy linkLink copied to clipboard!
| Enum Values |
|---|
| PROVIDER_TYPE_UNSPECIFIED |
| PROVIDER_TYPE_AWS |
| PROVIDER_TYPE_GCP |
| PROVIDER_TYPE_AZURE |
23.3.7.3. ProtobufAny Copy linkLink copied to clipboard!
Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.
Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.
Example 1: Pack and unpack a message in C++.
Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
...
}
Example 2: Pack and unpack a message in Java.
Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
any.Unpack(foo)
...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
...
}
The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".
23.3.7.3.1. JSON representation Copy linkLink copied to clipboard!
The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:
package google.profile;
message Person {
string first_name = 1;
string last_name = 2;
}
{
"@type": "type.googleapis.com/google.profile.Person",
"firstName": <string>,
"lastName": <string>
}
If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):
{
"@type": "type.googleapis.com/google.protobuf.Duration",
"value": "1.212s"
}
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| typeUrl | String |
A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in | |||
| value | byte[] | Must be a valid serialized protocol buffer of the above specified type. | byte |
23.3.7.4. RuntimeError Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| error | String | ||||
| code | Integer | int32 | |||
| message | String | ||||
| details | List of ProtobufAny |
23.3.7.5. V1DiscoveredCluster Copy linkLink copied to clipboard!
DiscoveredCluster represents a cluster discovered from a cloud source.
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | UUIDv5 generated deterministically from the tuple (metadata.id, metadata.type, source.id). | |||
| metadata | |||||
| status | STATUS_UNSPECIFIED, STATUS_SECURED, STATUS_UNSECURED, | ||||
| source |
23.3.7.6. V1DiscoveredClusterCloudSource Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String |
23.3.7.7. V1DiscoveredClusterMetadata Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| id | String | Represents a unique ID under which the cluster is registered with the cloud provider. Matches storage.ClusterMetadata.id for secured clusters. | |||
| name | String | Represents the name under which the cluster is registered with the cloud provider. Matches storage.ClusterMetadata.name for secured clusters. | |||
| type | UNSPECIFIED, AKS, ARO, EKS, GKE, OCP, OSD, ROSA, | ||||
| providerType | PROVIDER_TYPE_UNSPECIFIED, PROVIDER_TYPE_AWS, PROVIDER_TYPE_GCP, PROVIDER_TYPE_AZURE, | ||||
| region | String | The region as reported by the cloud provider. | |||
| firstDiscoveredAt | Date | Timestamp at which the cluster was first discovered by the cloud source. | date-time |
23.3.7.8. V1DiscoveredClusterStatus Copy linkLink copied to clipboard!
- STATUS_UNSPECIFIED: The status of the cluster is unknown. May occur if a secured cluster is missing the metadata for a possible match.
- STATUS_SECURED: The discovered cluster was matched with a secured cluster.
- STATUS_UNSECURED: The discovered cluster was not matched with a secured cluster.
| Enum Values |
|---|
| STATUS_UNSPECIFIED |
| STATUS_SECURED |
| STATUS_UNSECURED |
23.3.7.9. V1GetDiscoveredClusterResponse Copy linkLink copied to clipboard!
| Field Name | Required | Nullable | Type | Description | Format |
|---|---|---|---|---|---|
| cluster |